package sialocacao;

/**
 * <p>Title: Database.java </p>
 * <p>DesgetCocription: Respons\uFFFDvel pelo controle de conex\uFFFDo com o banco de dados. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: F\uFFFDbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          F\uFFFDbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da N\uFFFDbrega Medeiros
 * @version 1.0
 */

import java.sql.*;
import org.apache.commons.pool.impl.GenericObjectPool;
import org.apache.commons.dbcp.PoolingDriver;
import org.apache.commons.dbcp.PoolableConnectionFactory;
import org.apache.commons.dbcp.DriverManagerConnectionFactory;


public class Database {

// NOVOS ATRIBUTOS
  private static Database singleton;

  /*
   * Driver do BD.
   */
  private String driver = "org.postgresql.Driver";
  //private String driver = "sun.jdbc.odbc.JdbcOdbcDriver";

  /*
   * URL para acessar o BD.
   */
  private String url = "jdbc:postgresql://localhost/sialocacaoplus";
  //private String url = "jdbc:odbc:sialocacaoplus";

  /*
   * Usu\uFFFDrio para acessar o BD.
   */
  private String user = "lecl";
  //private String user = "";

  /*
   * Senha para acessar o BD.
   */
  private String password = "C1s0Pr&";
  //private String password = "";

  /**
   * Construtor privado para o pool de conexes ao Banco de Dados - utiliza-se de um singleton.
   * @throws Exception Quando no  possvel localizar o banco de dados.
   */
  private Database() throws Exception {
    try {
      Class.forName(driver);
      GenericObjectPool connectionPool = new GenericObjectPool(null);
      connectionPool.setMaxActive(5);
      connectionPool.setMaxIdle(5);
      DriverManagerConnectionFactory connectionFactory = new DriverManagerConnectionFactory(url, user, password);
      PoolableConnectionFactory poolableConnectionFactory = new PoolableConnectionFactory(connectionFactory,connectionPool,null,null,false,true);
      PoolingDriver driver = new PoolingDriver();
      driver.registerPool("pool",connectionPool);
    } catch (Exception e) {
            throw new Exception(e.getMessage());
    }
  }

  /**
   * Singleton de criao de uma instncia do pool para acesso ao banco de dados.
   * @throws Exception Quando no  possvel obter a instncia.
   */
  public static Database instance() throws Exception {
          if (singleton == null) {
                  singleton = new Database();
          }
          return singleton;
  }

  /**
   * Retorna uma conexo ao Banco de Dados obtida do pool.
   * @return Uma conexo ao banco de dados proviniente de um pool.
   * @throws SQLException Quando no  possvel abrir a conexo.
   */
  public Connection getConnection() throws SQLException {
    Connection con = DriverManager.getConnection("jdbc:apache:commons:dbcp:pool");
    con.setAutoCommit(false);
    return con;
  }


  /**
   * Devolve a conexo ao pool.
   * @parameter con A conexo a ser liberada.
   */
  public void returnConnection(Connection con) {
    try {
      con.commit();
      con.close();
    } catch(SQLException e) {
    }
  }

}