package sialocacao;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

import sialocacao.*;

import sialocacao.professor.*;
import sialocacao.professor.excecoes.*;
import sialocacao.sala.*;
import sialocacao.sala.excecoes.*;
import sialocacao.disciplina.*;
import sialocacao.alocacao.*;
import sialocacao.util.Data;

import sialocacao.timetabling.*;

/**
 * <p>Title: SIAlocacao</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class Teste {
  public static void main(String[] args) throws Exception{
      SIAlocacao sialocacao = new SIAlocacao();

/*      String diaInicio = req.getParameter( "dia_inicio" );
      String mesInicio = req.getParameter( "mes_inicio" );
      String anoInicio = req.getParameter( "ano_inicio" );

      String diaFim = req.getParameter( "dia_fim" );
      String mesFim = req.getParameter( "mes_fim" );
      String anoFim = req.getParameter( "ano_fim" );*/

      String dataInicio = "01/09/2003";
      String dataFim = "06/09/2003";

      Data dataAtual =
        new Data(dataInicio);

      Data dataFinal =
        new Data(dataFim);

      //Criando uma data inicio
      Data dataDeHoje = new Data();

      //Recebendo o conjunto de salas existentes.
      ArrayList salas = sialocacao.listarSalas();

      //Recebendo o conjunto de horrios existentes.
      ArrayList horarios = sialocacao.listarHorarios();

      //Recebendo o conjunto de professores existentes.
      ArrayList professores = sialocacao.listarProfessores();

      //Recebendo o conjunto de disciplinas existentes.
      ArrayList disciplinas = sialocacao.listarDisciplinas();

      //Recebendo o conjunto de categorias existentes.
      ArrayList categorias = sialocacao.listarCategorias();

      //Preenchendo o Map disciplinasProfessores
      Map disciplinasProfessores = new HashMap();

      Iterator it = disciplinas.iterator();
      while (it.hasNext()){
        Disciplina disciplina = (Disciplina)it.next();
        int codDisciplina = disciplina.getCodigo();
        Professor professor = sialocacao.buscarProfessorDeDisciplina(codDisciplina);
        /*if(professor==null) {
            res.sendRedirect("/sialocacao/professor_disciplina.jsp?mensagem=Existem disciplinas sem professor associado!");

            return;
        }*/
        int codProfessor = professor.getCodigo();
        disciplinasProfessores.put(new Integer(codDisciplina), new Integer(codProfessor));
      }

      //Preenchendo o Map preferenciasProfessores
      Map preferenciasProfessores = new HashMap();

      it = professores.iterator();
      while (it.hasNext()){
        Professor professor = (Professor)it.next();
        int codProfessor = professor.getCodigo();

        //Preenchendo o Map preferenciasHorarios
        Map preferenciasHorarios = sialocacao.buscarPrioridades(professor);

        preferenciasProfessores.put(new Integer(codProfessor), preferenciasHorarios);
      }


       // preenchendo adequao das salas de cada disciplinas
       Map adequacaoDisciplinasSalas = new HashMap();

       it = disciplinas.iterator();
       while(it.hasNext()) {
         Disciplina disciplina = (Disciplina)it.next();
         Map adequacao = sialocacao.buscarPrioridades(disciplina, categorias);
         adequacaoDisciplinasSalas.put(new Integer(disciplina.getCodigo()), adequacao);
       }

      // preenchendo relao salas categorias
      Map salasCategorias = new HashMap();

      it = salas.iterator();
      while(it.hasNext()) {
        Sala sala = (Sala)it.next();
        salasCategorias.put(new Integer(sala.getCodigo()), new Integer(sala.getCodigoCategoria()));
      }

      // preenchendo relao disciplina, nmero de aulas
      Map aulasDisciplinas = new HashMap();

      it = disciplinas.iterator();
      while(it.hasNext()) {
        Disciplina disciplina = (Disciplina)it.next();
        aulasDisciplinas.put(new Integer(disciplina.getCodigo()), new Integer(disciplina.getCargaHoraria()));
      }


      int diasUteis = 6;

      //Chamada do Algoritmo atravs do mtodo proporAlocacao

      AlgoritmoTimetabling algoritmo = new TimetablingGenetico();
      Collection alocacoes = algoritmo.proporAlocacao(disciplinasProfessores, preferenciasProfessores,
                     adequacaoDisciplinasSalas, salasCategorias, aulasDisciplinas, diasUteis,
                     salas, horarios, professores, disciplinas);

      Calendar calendarioInicial = GregorianCalendar.getInstance();
      Calendar calendarioFinal = GregorianCalendar.getInstance();

      //Setando calendario inicial
      calendarioInicial.set( Calendar.YEAR, dataAtual.getAno() );
      // Setar mes inicial do periodo de inicio -1 pois no calendario comea do zero
      calendarioInicial.set(Calendar.MONTH, dataAtual.getMes() - 1 );
      calendarioInicial.set(Calendar.DAY_OF_MONTH, dataAtual.getDia());

      //Setando calendario final
      calendarioFinal.set( Calendar.YEAR, dataFinal.getAno() );
      // Setar mes inicial do periodo de inicio -1 pois no calendario comea do zero
      calendarioFinal.set(Calendar.MONTH, dataFinal.getMes() - 1 );
      calendarioFinal.set(Calendar.DAY_OF_MONTH, dataFinal.getDia());

      int diaSemanaPeriodoInicio = calendarioInicial.get(GregorianCalendar.DAY_OF_WEEK);

      //Criando uma data final para ser usada do do-while abaixo
/*      Data dataFinal = new Data(calendarioFinal.get(GregorianCalendar.DAY_OF_MONTH),
                                calendarioFinal.get(GregorianCalendar.MONTH)+1,
                                calendarioFinal.get(GregorianCalendar.YEAR));*/

      try{
        Alocacao alocacao;
        Horario horario = new Horario();
        Iterator itAlocacoes = alocacoes.iterator();
        String diaSemanaAlocacao = null;

        int valorDiaSemana = 0, valor = 0;
        ArrayList conflitos = new ArrayList();

        while(itAlocacoes.hasNext()){
          alocacao = (Alocacao) itAlocacoes.next();
          horario = sialocacao.buscarHorario(alocacao.getCodHorario());
          diaSemanaAlocacao = horario.getDiaDaSemana();

          valorDiaSemana = horario.getValorDiaSemana(diaSemanaAlocacao);
          valor = valorDiaSemana - diaSemanaPeriodoInicio;

          //Criando uma data inicio
          dataAtual =
            new Data(dataInicio);

          if(valor >= 0) {
              // incrementa resultado
              dataAtual = dataAtual.getProximaData(valor);
          } else {
              // Incrementa (7 + resultado)
              dataAtual = dataAtual.getProximaData(7+valor);
          }

          Sala sala = null;
          Disciplina disciplina = null;
          Professor professor = null;
          // faz a alocao de 7 em 7 dias at o perodo final
          while(dataAtual.menorQue(dataFinal) || dataAtual.equals(dataFinal)) {
             try {
              horario.setCodigo(alocacao.getCodHorario());

              sala = new Sala();
              sala.setCodigo(alocacao.getCodSala());

              disciplina = new Disciplina();
              disciplina.setCodigo(alocacao.getCodDisciplina());

              professor = new Professor();
              professor.setCodigo(alocacao.getCodProfessor());

              sialocacao.alocar(sala, disciplina, horario, professor, dataAtual);


            } catch(ProfessorAlocadoException e) {
              Professor prof = sialocacao.buscarProfessor(professor.getCodigo());
              conflitos.add("Professor j est alocado neste horrio -> " +
                            prof.getNome() + " s " + horario.getHoraInicio() +
                             "-" + horario.getHoraFim() + " em " + dataAtual.toString());

            } catch(SalaAlocadaException e) {
              sala = sialocacao.buscarSala(sala.getCodigo());
              conflitos.add("Sala j est alocada neste horrio -> "
                            + sala.getDescricao() + " s " + horario.getHoraInicio()
                            + "-" + horario.getHoraFim() + " em " + dataAtual.toString());
            } catch(Exception e) {
              conflitos.add("\tNo foi possivel efetuar operao: " + e.getMessage());
            } finally {
              dataAtual = dataAtual.getProximaData(7);
            }
          }

        }


        return;
      }catch(SIAlocacaoException ex){

           return;
      }catch(Exception ex){


         return;
     }
  }
}