package sialocacao.alocacao;

/**
 * <p>Title: Alocacao.java </p>
 * <p>Description: Responsvel por manipular o objeto alocacao. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 2.0
 */

import sialocacao.util.*;

public class Alocacao {

  /*
   * Cdigo da alocacao.
   */
  private int codigo;

  /*
   * Cdigo da Sala.
   */
  private int codSala;

  /*
   * Cdigo da Horario.
   */
  private int codHorario;

  /*
   * Cdigo da Disciplina.
   */
  private int codDisciplina;

  /*
   * Cdigo da Professor..
   */
  private int codProfessor;

  /*
   * Data da Alocao.
   */
  private Data data;

  /*
   * Construtor vazio.
   */
  public Alocacao() {
  }

  /*
   * Construtor
   */
  public Alocacao(int codigo, int codSala, int codHorario, int codDisciplina, int codProfessor, Data data) {
    setCodigo(codigo);
    setCodSala(codSala);
    setCodHorario(codHorario);
    setCodDisciplina(codDisciplina);
    setCodProfessor(codProfessor);
    setData(data);
  }

  /**
   * Pega cdigo da Alocacao.
   * @return int
   */
  public int getCodigo() {
    return this.codigo;
  }

  /**
   * Define cdigo da Alocacao.
   * @param codigo
   */
  public void setCodigo(int codigo) {
    this.codigo = codigo;
  }

  /**
   * Pega cdigo da Sala.
   * @return int
   */
  public int getCodSala() {
    return this.codSala;
  }

  /**
   * Define cdigo da Sala.
   * @param codSala
   */
  public void setCodSala(int codSala) {
    this.codSala = codSala;
  }

  /**
   * Pega cdigo da Horario.
   * @return int
   */
  public int getCodHorario() {
    return this.codHorario;
  }

  /**
   * Define cdigo da Horario.
   * @param codHorario
   */
  public void setCodHorario(int codHorario) {
    this.codHorario = codHorario;
  }

  /**
   * Pega cdigo da Disciplina.
   * @return int
   */
  public int getCodDisciplina() {
    return this.codDisciplina;
  }

  /**
   * Define cdigo do Disciplina.
   * @param codDisciplina
   */
  public void setCodDisciplina(int codDisciplina) {
    this.codDisciplina = codDisciplina;
  }

  /**
   * Pega cdigo da Professor.
   * @return int
   */
  public int getCodProfessor() {
    return this.codProfessor;
  }

  /**
   * Define cdigo do Professor.
   * @param codProfessor
   */
  public void setCodProfessor(int codProfessor) {
    this.codProfessor = codProfessor;
  }

  /**
   * Pega data de alocao.
   * @return String
   */
  public Data getData() {
    return this.data;
  }

  /**
   * Define data de alocao.
   * @param data
   */
  public void setData(Data data) {
    this.data = data;
  }

  /**
   * Compara dois objetos alocacao.
   * @param alocacao
   * @return boolean
   */
  public boolean equals(Alocacao alocacao) {
    boolean result = false;

    if((this.codigo == alocacao.getCodigo()) &&
       (this.codSala == alocacao.getCodSala()) &&
       (this.codHorario == alocacao.getCodHorario()) &&
       (this.codDisciplina == alocacao.getCodDisciplina()) &&
       (this.codProfessor == alocacao.getCodProfessor()) &&
       (this.data.equals(alocacao.getData())) )

      result = true;

    return result;
  }

  /**
   * Concatena atributos do objeto alocao em uma string.
   * @return String
   */
  public String toString() {
    StringBuffer str = new StringBuffer();

    str.append("sialocacao.alocacao.Alocacao: (");
    str.append(this.codigo);
    str.append(", ");
    str.append(this.codSala);
    str.append(", ");
    str.append(this.codHorario);
    str.append(", ");
    str.append(this.codDisciplina);
    str.append(", ");
    str.append(this.codProfessor);
    str.append(", ");
    str.append(this.data);

    str.append(")");

    return str.toString();
  }
}