package sialocacao.alocacao.servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

import sialocacao.*;

import sialocacao.professor.*;
import sialocacao.professor.excecoes.*;
import sialocacao.sala.*;
import sialocacao.sala.excecoes.*;
import sialocacao.disciplina.*;
import sialocacao.alocacao.*;
import sialocacao.util.Data;

import sialocacao.timetabling.*;

/**
 * <p>Title: ServletSugerirAlocacao </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
public class ServletAlocarSugestoes extends HttpServlet{
  public void doGet( HttpServletRequest req, HttpServletResponse res )
    throws ServletException, IOException{

    doPost(req, res);
  }

  public void doPost( HttpServletRequest req, HttpServletResponse res )
    throws ServletException, IOException{

      SIAlocacao sialocacao = new SIAlocacao();

/*      String diaInicio = req.getParameter( "dia_inicio" );
      String mesInicio = req.getParameter( "mes_inicio" );
      String anoInicio = req.getParameter( "ano_inicio" );

      String diaFim = req.getParameter( "dia_fim" );
      String mesFim = req.getParameter( "mes_fim" );
      String anoFim = req.getParameter( "ano_fim" );*/

      String dataInicio = req.getParameter( "dataInicio" );
      String dataFim = req.getParameter( "dataFim" );

      Data dataAtual =
        new Data(dataInicio);

      Data dataFinal =
        new Data(dataFim);

      //Criando uma data inicio
      Data dataDeHoje = new Data();

      if(dataFinal.menorQue(dataAtual)){
        res.sendRedirect("/sialocacao/mapaAlocacaoSugerido.jsp?mensagem=ERRO!"+
        " Perodo de incio(" + dataAtual.toString() + ") no pode ser maior que " +
        "o perodo final(" + dataFinal.toString() + ")!");

        return;
      }
      if(dataAtual.menorQue(dataDeHoje)){
        res.sendRedirect("/sialocacao/mapaAlocacaoSugerido.jsp?mensagem=ERRO!"+
                        "No  possvel fazer alocaes numa data ("+
                         dataAtual.toString()+") anterior a de hoje(" +
                         dataDeHoje.toString() + ")!");
        return;
      }

      HttpSession secao = req.getSession(true);
      Collection alocacoes = (Collection) secao.getAttribute("alocacoes_sugeridas");

      Calendar calendarioInicial = GregorianCalendar.getInstance();
      Calendar calendarioFinal = GregorianCalendar.getInstance();

      //Setando calendario inicial
      calendarioInicial.set( Calendar.YEAR, dataAtual.getAno() );
      // Setar mes inicial do periodo de inicio -1 pois no calendario comea do zero
      calendarioInicial.set(Calendar.MONTH, dataAtual.getMes() - 1 );
      calendarioInicial.set(Calendar.DAY_OF_MONTH, dataAtual.getDia());

      //Setando calendario final
      calendarioFinal.set( Calendar.YEAR, dataFinal.getAno() );
      // Setar mes inicial do periodo de inicio -1 pois no calendario comea do zero
      calendarioFinal.set(Calendar.MONTH, dataFinal.getMes() - 1 );
      calendarioFinal.set(Calendar.DAY_OF_MONTH, dataFinal.getDia());

      int diaSemanaPeriodoInicio = calendarioInicial.get(GregorianCalendar.DAY_OF_WEEK);

      //Criando uma data final para ser usada do do-while abaixo
/*      Data dataFinal = new Data(calendarioFinal.get(GregorianCalendar.DAY_OF_MONTH),
                                calendarioFinal.get(GregorianCalendar.MONTH)+1,
                                calendarioFinal.get(GregorianCalendar.YEAR));*/

      try{
        Alocacao alocacao;
        Horario horario = new Horario();
        Iterator itAlocacoes = alocacoes.iterator();
        String diaSemanaAlocacao = null;

        int valorDiaSemana = 0, valor = 0;
        ArrayList conflitos = new ArrayList();

        while(itAlocacoes.hasNext()){
          alocacao = (Alocacao) itAlocacoes.next();
          horario = sialocacao.buscarHorario(alocacao.getCodHorario());
          diaSemanaAlocacao = horario.getDiaDaSemana();

          valorDiaSemana = horario.getValorDiaSemana(diaSemanaAlocacao);
          valor = valorDiaSemana - diaSemanaPeriodoInicio;

          //Criando uma data inicio
          //Criando uma data inicio
          dataAtual =
            new Data(dataInicio);

          if(valor >= 0) {
              // incrementa resultado
              dataAtual = dataAtual.getProximaData(valor);
          } else {
              // Incrementa (7 + resultado)
              dataAtual = dataAtual.getProximaData(7+valor);
          }

          Sala sala = null;
          Disciplina disciplina = null;
          Professor professor = null;
          // faz a alocao de 7 em 7 dias at o perodo final
          while(dataAtual.menorQue(dataFinal) || dataAtual.equals(dataFinal)) {
             try {
              horario.setCodigo(alocacao.getCodHorario());

              sala = new Sala();
              sala.setCodigo(alocacao.getCodSala());

              disciplina = new Disciplina();
              disciplina.setCodigo(alocacao.getCodDisciplina());

              professor = new Professor();
              professor.setCodigo(alocacao.getCodProfessor());

              sialocacao.alocar(sala, disciplina, horario, professor, dataAtual);


            } catch(ProfessorAlocadoException e) {
              Professor prof = sialocacao.buscarProfessor(professor.getCodigo());
              conflitos.add("Professor j est alocado neste horrio -> " +
                            prof.getNome() + " s " + horario.getHoraInicio() +
                             "-" + horario.getHoraFim() + " em " + dataAtual.toString());

            } catch(SalaAlocadaException e) {
              sala = sialocacao.buscarSala(sala.getCodigo());
              conflitos.add("Sala j est alocada neste horrio -> "
                            + sala.getDescricao() + " s " + horario.getHoraInicio()
                            + "-" + horario.getHoraFim() + " em " + dataAtual.toString());
            } catch(Exception e) {
              conflitos.add("\tNo foi possivel efetuar operao: " + e.getMessage());
            } finally {
              dataAtual = dataAtual.getProximaData(7);
            }
          }

        }
        secao.setAttribute("conflitos", conflitos );
        res.sendRedirect("/sialocacao/mapaAlocacao.jsp?semana=atual&mensagem=Alocaes Realizadas com "+
                         "sucesso!");

        return;
      }catch(SIAlocacaoException ex){
           res.sendRedirect("/sialocacao/mapaAlocacaoSugerido.jsp?semana=atual&mensagem=ERRO! No foi "+
           "possvel fazer a alocao! ("+ex.getDescription()+")");

           return;
      }catch(Exception ex){
         res.sendRedirect("/sialocacao/mapaAlocacaoSugerido.jsp?semana=atual&mensagem=ERRO! No foi "+
         "possvel fazer a alocao!("+ex.getMessage()+")");

         return;
     }
  }
}
