package sialocacao.alocacao.servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

import sialocacao.*;

import sialocacao.professor.*;
import sialocacao.sala.*;
import sialocacao.disciplina.*;
import sialocacao.alocacao.*;
import sialocacao.util.Data;

import sialocacao.timetabling.*;

/**
 * <p>Title: ServletSugerirAlocacao </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
public class ServletSugerirAlocacao extends HttpServlet{
  public void doGet( HttpServletRequest req,
                     HttpServletResponse res )
    throws ServletException, IOException{

    doPost(req, res);
  }

  public void doPost( HttpServletRequest req,
                      HttpServletResponse res )
    throws ServletException, IOException{

    try{
      SIAlocacao sialocacao = new SIAlocacao();

      if(!sialocacao.todasDisciplinasAssociadas()){
        res.sendRedirect("/sialocacao/professor_disciplina.jsp?mensagem="+
          "Existem disciplinas sem professor associado!");

        return;
      }

      //Recebendo o conjunto de salas existentes.
      ArrayList salas = sialocacao.listarSalas();

      //Recebendo o conjunto de horrios existentes.
      ArrayList horarios = sialocacao.listarHorarios();

      //Recebendo o conjunto de professores existentes.
      ArrayList professores = sialocacao.listarProfessores();

      //Recebendo o conjunto de disciplinas existentes.
      ArrayList disciplinas = sialocacao.listarDisciplinas();

      //Recebendo o conjunto de categorias existentes.
      ArrayList categorias = sialocacao.listarCategorias();

      //Preenchendo o Map disciplinasProfessores
      Map disciplinasProfessores = new HashMap();

      Iterator it = disciplinas.iterator();
      while (it.hasNext()){
        Disciplina disciplina = (Disciplina)it.next();
        int codDisciplina = disciplina.getCodigo();
        Professor professor = sialocacao.buscarProfessorDeDisciplina(codDisciplina);
        /*if(professor==null) {
            res.sendRedirect("/sialocacao/professor_disciplina.jsp?mensagem=Existem disciplinas sem professor associado!");

            return;
        }*/
        int codProfessor = professor.getCodigo();
        disciplinasProfessores.put(new Integer(codDisciplina), new Integer(codProfessor));
      }

      //Preenchendo o Map preferenciasProfessores
      Map preferenciasProfessores = new HashMap();

      it = professores.iterator();
      while (it.hasNext()){
        Professor professor = (Professor)it.next();
        int codProfessor = professor.getCodigo();

        //Preenchendo o Map preferenciasHorarios
        Map preferenciasHorarios = sialocacao.buscarPrioridades(professor);

        preferenciasProfessores.put(new Integer(codProfessor), preferenciasHorarios);
      }


       // preenchendo adequao das salas de cada disciplinas
       Map adequacaoDisciplinasSalas = new HashMap();

       it = disciplinas.iterator();
       while(it.hasNext()) {
         Disciplina disciplina = (Disciplina)it.next();
         Map adequacao = sialocacao.buscarPrioridades(disciplina, categorias);
         adequacaoDisciplinasSalas.put(new Integer(disciplina.getCodigo()), adequacao);
       }

      // preenchendo relao salas categorias
      Map salasCategorias = new HashMap();

      it = salas.iterator();
      while(it.hasNext()) {
        Sala sala = (Sala)it.next();
        salasCategorias.put(new Integer(sala.getCodigo()), new Integer(sala.getCodigoCategoria()));
      }

      // preenchendo relao disciplina, nmero de aulas
      Map aulasDisciplinas = new HashMap();

      it = disciplinas.iterator();
      while(it.hasNext()) {
        Disciplina disciplina = (Disciplina)it.next();
        aulasDisciplinas.put(new Integer(disciplina.getCodigo()), new Integer(disciplina.getCargaHoraria()));
      }


      int diasUteis = 6;

      //Chamada do Algoritmo atravs do mtodo proporAlocacao

      AlgoritmoTimetabling algoritmo = new TimetablingGenetico();
      Collection alocacoes = algoritmo.proporAlocacao(disciplinasProfessores, preferenciasProfessores,
                     adequacaoDisciplinasSalas, salasCategorias, aulasDisciplinas, diasUteis,
                     salas, horarios, professores, disciplinas);

      req.getSession(true).setAttribute("alocacoes_sugeridas" , alocacoes);
      res.sendRedirect("/sialocacao/mapaAlocacaoSugerido.jsp?mensagem=Mapa de alocao sugerido!");

      return;
    }catch(SIAlocacaoException ex){ex.printStackTrace();
         res.sendRedirect("/sialocacao/mapaAlocacaoSugerido.jsp?semana=atual&mensagem=ERRO! No foi "+
         "possvel fazer a alocao! ("+ex.getDescription()+")");

         return;
    }catch(Exception ex){ex.printStackTrace();
       res.sendRedirect("/sialocacao/mapaAlocacaoSugerido.jsp?semana=atual&mensagem=ERRO! No foi "+
       "possvel fazer a alocao! ()");

       return;
     }


  }
}