package sialocacao.disciplina.servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import sialocacao.*;
import sialocacao.disciplina.*;
import java.util.*;
import sialocacao.sala.Categoria;


public class ServletAlterarDisciplina extends HttpServlet{
  public void doGet( HttpServletRequest req,
                     HttpServletResponse res )
    throws ServletException, IOException{

    doPost(req, res);
  }

  public void doPost( HttpServletRequest req,
                      HttpServletResponse res )
    throws ServletException, IOException{

    boolean remover =
      req.getParameter("remover") != null;

    //testa se obotao clicado foi o 'Remover'; nesse caso redireciona para o
    //ServletRemoverDisciplina
    if(remover){
      res.sendRedirect("/sialocacao/servlet/sialocacao.disciplina.servlets."+
        "ServletExcluirDisciplina?disciplinas="+req.getParameter( "codigo" ));

      return;
    }

    int codigo = Integer.parseInt(req.getParameter( "codigo" ));
    String descricao = req.getParameter( "descricao" );
    int cargaHoraria = Integer.parseInt( req.getParameter( "cargaHoraria" ) );
    String ementa = req.getParameter( "ementa" );

    HttpSession sessao = req.getSession(true);
    List categorias = (List)sessao.getAttribute("categorias");
    Map prioridades = new HashMap();
    for(int i=0; i<categorias.size(); i++) {
        String codCategoria = ((Categoria)categorias.get(i)).getCodigo()+"";
        String codPreferencia = req.getParameter("preferencia_"+codCategoria);
        prioridades.put(codCategoria, codPreferencia);
    }


    try{
      SIAlocacao sialocacao =
        new SIAlocacao();

      sialocacao.alterarDisciplina(new Disciplina(codigo,
                                                  descricao,
                                                  cargaHoraria,
                                                  ementa),
                                   prioridades);

      res.sendRedirect("/sialocacao/listar_disciplinas.jsp");

      return;
    }catch(Exception ex){ex.printStackTrace();
       res.sendRedirect("/sialocacao/listar_disciplinas.jsp?mensagem=Problemas"+
        "ao alterar disciplina!");

       return;
     }
  }
}