package sialocacao.professor.excecoes;

/**
 * <p>Title: SIAlocacao</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

import sialocacao.*;
import sialocacao.professor.*;

 public class ProfessorJaCadastradoException extends SIAlocacaoException {

  /*
   * Construtor default.
   */
  public ProfessorJaCadastradoException() {
  }


  /*
   * Construtor responsvel por definir o cdigo do professor j cadastrado.
   */
  public ProfessorJaCadastradoException(int codProfessor) {
    setDescription(getDescription(codProfessor));
  }

  /*
   * Construtor responsvel por definir o nome do professor j cadastrado.
   */
  public ProfessorJaCadastradoException(String nome) {
    setDescription(getDescription(nome));
  }

  /*
   * Construtor responsvel por definir o professor j cadastrado.
   */
  public ProfessorJaCadastradoException(Professor professor) throws
      IllegalArgumentException {

    if (professor == null) {
      throw new IllegalArgumentException("professor == null");
    }

    setDescription(getDescription(professor.getCodigo()));
  }

  /*
   * Define descrio da exceo, passando o cdigo do professor j cadastrado.
   * @param codDisciplina
   */
  private String getDescription(int codProfessor) {
    StringBuffer description =
        new StringBuffer("J existe um professor cadastrado com esse cpf, seu codigo :");

    description.append(codProfessor);

    return description.toString();
  }

  /*
   * Define descrio da exceo, passando o nome do professor alocado.
   * @param nome
   */
  private String getDescription(String nome) {
    StringBuffer description =
        new StringBuffer("J existe um professor cadastrado com esse cpf, seu nome :");

    description.append(nome);

    return description.toString();
  }
}