package sialocacao.sala;

/**
 * <p>Title: Sala.java </p>
 * <p>Description: Responsvel por manipular o objeto categoria. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

public class Categoria {

  /*
   * Cdigo da categoria.
   */
  private int codigo;

  /*
   * Descrio da categoria.
   */
  private String descricao;

  /*
   * Construtor vazio.
   */
  public Categoria() {
  }

  /*
   * Construtor responsvel por definir cdigo, descrio
   */
  public Categoria(int codigo, String descricao) {
    setCodigo(codigo);
    setDescricao(descricao);
  }

  /**
   * Pega cdigo da categoria.
   * @return int
   */
  public int getCodigo() {
    return this.codigo;
  }

  /**
   * Define cdigo da categoria.
   * @param codigo
   */
  public void setCodigo(int codigo) {
    this.codigo = codigo;
  }

  /**
   * Pega descrio da categoria.
   * @return int
   */
  public String getDescricao() {
    return this.descricao;
  }

  /**
   * Define descrio da categoria.
   * @param descricao
   */
  public void setDescricao(String descricao) {
    this.descricao = descricao;
  }

  /**
   * Compara dois objetos categoria.
   * @param sala
   * @return boolean
   */
  public boolean equals(Categoria categoria) {
    boolean result = false;

    if((this.codigo == categoria.getCodigo()) &&
      (this.descricao.equalsIgnoreCase(categoria.getDescricao().trim())) ) {
        result = true;
    }

    return result;
  }

  /**
   * Concatena atributos do objeto sala em uma string.
   * @return String
   */
  public String toString() {
    StringBuffer str =
        new StringBuffer();

    str.append("sialocacao.sala.Categoria: (");
    str.append(this.codigo);
    str.append(", ");
    str.append(this.descricao);
    str.append(")");

    return str.toString();
  }
}