package sialocacao.sala.negocio;

/**
 * <p>Title: CadastroSalas.java </p>
 * <p>Description: Implementa a camanda de negcio de salas. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

import java.util.*;

import sialocacao.*;
import sialocacao.sala.*;
import sialocacao.sala.database.*;
import sialocacao.sala.excecoes.*;

public class CadastroCategorias implements ICadastroCategorias {

  /*
   * Instncia do repositrio de categorias.
   */
  private ICategoriaDatabase categoriaDatabase;

  /*
   * Construtor default definindo o repositrio de categorias.
   *
   */
  public CadastroCategorias() throws Exception{
    setCategoriaDatabase(new CategoriaDatabase());
  }

  /*
   * Construtor definindo o repositrio de salas.
   * @param salaDatabase
   */
  public CadastroCategorias(ICategoriaDatabase salaDatabase) {
    setCategoriaDatabase(salaDatabase);
  }

  /*
   * Define repositrio de salas.
   * @param salaDatabase
   */
  public void setCategoriaDatabase(ICategoriaDatabase categoriaDatabase) throws
      IllegalArgumentException {

    if (categoriaDatabase == null) {
      throw new IllegalAccessError("salaDatabase == null");
    }

    this.categoriaDatabase = categoriaDatabase;
  }

  /*
   * Lista salas do sistema.
   * @return ArrayList
   */
  public ArrayList listarCategorias() throws SIAlocacaoException {

    return this.categoriaDatabase.listarCategorias();
  }
}
